<?php
//SYNC Commander
//Command line arguments reader module
//Chen Qing-can, 2007 autumn, Nanhai China
//[GB2312] ӶϺ

//---------------------------------------------------------------------------
$push_error_reporting = error_reporting(E_ERROR); //skip the warnings about PEAR library
require_once('PEAR/getopt.php');
error_reporting($push_error_reporting);
require_once('strxx.php');

//---------------------------------------------------------------------------
class Args
{
	private $args;
	
	//-------------------------------------------------------------------
	//command line arguments -> $this->args
	//file path not ends with DIR_SEP
	//ftp path ends with /
	public function Args()
	{
		//read argv via getopt
		global $argv;
		$getopt = new Console_Getopt;
		$push_error_reporting = error_reporting(E_ERROR); //skip the warnings about PEAR library
		$opt = $getopt->getopt($argv, null, array(
			'from=', 'from-user==', 'from-password==',
			'to=', 'to-user==', 'to-password==',
			'do=',
			'help',
			));
		error_reporting($push_error_reporting);
		if (is_array($opt) == false or is_array($opt[0]) == false)
			die_help();
		$this->args = array();
		foreach ($opt[0] as $i)
			$this->args[$i[0]] = $i[1];

		//need help?
		if (array_key_exists('--help', $this->args))
			die(lang(S_HELP));
		
		//check whether the required arguments are provided
		$this->assert_has_arg_value('--from');
		$this->assert_has_arg_value('--to');
		$this->assert_has_arg_value('--do');
		
		//indirect fields
		$this->indirect_args('--from');
		$this->indirect_args('--to');
		if ($this->args['--from-protocol'] == 'ftp' and $this->args['--to-protocol'] == 'ftp')
			die(lang('FTP to FTP operation is not supported'));
		if ($this->args['--to-protocol'] == 'ftp' and $this->args['--to'] != '/')
			die(lang('Current version of wput has bugs when destination is not the root directory'));
		if ($this->args['--to-protocol'] == 'ftp' and $this->args['--do'] == 'sync')
			die(lang('Synchronization from file system to FTP server is not supported'));
		print_r($this->args);
	}
	
	//-------------------------------------------------------------------
	public function get($name)
	{ return(array_key_exists($name, $this->args) ? $this->args[$name] : null); }
	
	//-------------------------------------------------------------------
	private function assert_has_arg_value($name)
	{
		if (! array_key_exists($name, $this->args))
		{
			print(lang('Error: missing argument ') . $name . LINE_END);
			die_help();
		}
	}

	//-------------------------------------------------------------------
	private function indirect_args($prefix)
	{
		//protocol: file or ftp
		$this->args["$prefix-protocol"] =
			str_begins_with($this->args[$prefix], 'ftp://') ? 'ftp' : 'file';
			
		//file
		if ($this->args["$prefix-protocol"] == 'file')
		{
			if (str_ends_with($this->args[$prefix], DIR_SEP))
				$this->args[$prefix] = substr($this->args[$prefix], 0, -1);
		}
		
		//ftp
		else if ($this->args["$prefix-protocol"] == 'ftp')
		{
			$url = parse_url($this->args[$prefix]);
			$this->args["$prefix-host"] = $url['host'];
			$this->args["$prefix-port"] = array_key_exists('port', $url) ? $url['port'] : 21;
			$this->args[$prefix] = array_key_exists('path', $url) ? $url['path'] : '/';
			if (! str_ends_with($this->args[$prefix], '/'))
				$this->args[$prefix] .= '/';
			if (array_key_exists('user', $url))
				$this->args["$prefix-user"] = $url['user'];
			else
				$this->assert_has_arg_value("$prefix-user");
			if (array_key_exists('pass', $url))
				$this->args["$prefix-password"] = $url['pass'];
		}
		
		else assert(false);
	}
}
?>
