<?php
//SYNC Commander
//File list module
//Chen Qing-can, 2007 autumn, Nanhai China
//[GB2312] ӶϺ

//---------------------------------------------------------------------------
require_once('strxx.php');

//---------------------------------------------------------------------------
class DiskFileList
{
	//-------------------------------------------------------------------
	//return: success flag
	public function list_to_file($base_location, $file_handle)
	{
		assert(! str_ends_with($base_location, DIR_SEP));
		$dir = "DIR /S /B $base_location";
		print($dir); print(LINE_END);
		$h = popen($dir, 'r');
		if (! $h)
		{
			print(lang('Error: Failed to open the pipe to DIR command'));
			return(false);
		}
		$base_location_n = strlen($base_location);
		while (! feof($h))
		{
			fputs($file_handle, str_replace(DIR_SEP, '/', substr(fgets($h), $base_location_n)));
			fputs($file_handle, LINE_END);
		}
		pclose($h);
		return(true);
	}
}

//---------------------------------------------------------------------------
class FTPFileList
{
	private $host, $port, $user, $password;
	
	//-------------------------------------------------------------------
	public function FTPFileList($ftp_host, $ftp_port, $ftp_user, $ftp_password)
	{
		$this->host = $ftp_host;
		$this->port = $ftp_port;
		$this->user = $ftp_user;
		$this->password = $ftp_password;
	}
	
	//-------------------------------------------------------------------
	//return: success flag
	public function list_to_file($base_location, $file_handle)
	{
		assert(str_ends_with($base_location, '/'));
		print(lang('Connecting to the FTP server: ') . $this->host . LINE_END);
		$h = ftp_connect($this->host, $this->port);
		if (! $h)
		{
			print(lang('Error: Failed to connect to the FTP server: ') . $this->host);
			return(false);
		}
		if (! @ftp_login($h, $this->user, $this->password))
		{
			print(lang('Error: Failed to login the FTP server: ') . $this->host);
			return(false);
		}
		print(lang('Connected to ') . $this->host); print(LINE_END);
		ftp_pasv($h, true);
		ftp_raw($h, 'OPTS UTF8 OFF');
		$this->list_to_file_core($h, $base_location, ftp_rawlist($h, $base_location),  strlen($base_location) - 1, $file_handle);
		if (! ftp_close($h))
			print(lang('Warning: Failed to disconnect from the FTP server: ') . $this->host);
		return(true);
	}
	
	//-------------------------------------------------------------------
	private function list_to_file_core($ftp_handle, $base_location, $raw_list, $skip_n, $file_handle)
	{
		print('LIST ' . $base_location . LINE_END);
		//print_r($raw_list);
		//-r--r--r-- 1 ftp ftp              0 Dec 15 16:22 plain.txt
		//drwxr-xr-x 1 ftp ftp              0 Dec 16 13:53 folder-1
		if (! str_ends_with($base_location, '/'))
			$base_location .= '/';
		foreach ($raw_list as $list_1)
		{
			$ls = explode(' ', $list_1);
			$d = $ls[0][0];
			$n = end($ls);
			fputs($file_handle, substr($base_location, $skip_n));
			fputs($file_handle, $n);
			fputs($file_handle, LINE_END);
			if ($d == 'd')
				$this->list_to_file_core($ftp_handle, $base_location . $n, ftp_rawlist($ftp_handle, $base_location . $n), $skip_n, $file_handle);
		}
	}
}

//---------------------------------------------------------------------------
class CompareFileList
{
	//-------------------------------------------------------------------
	//$command_type: BAT FTP
	public function gen_clean_to_cmd($from_list_handle, $to_list_handle, $command_handle, $command_type, $base_location)
	{
		assert($command_type == 'BAT' or command_type == 'FTP');
		$from = '';
		for (;;)
		{
			$to = $this->get_list_1($to_list_handle);
			if (is_null($to))
				break;
			while (strcmp($from, $to) < 0)
			{
				$from = $this->get_list_1($from_list_handle);
				if (is_null($from))
				{
					$this->gen_clean_1($to, $command_handle, $command_type, $base_location);
					break;
				}
			}
			if (strcmp($from, $to) > 0)
				$this->gen_clean_1($to, $command_handle, $command_type, $base_location);
		}
	}
	
	//-------------------------------------------------------------------
	//skip blank line
	//return null if eof
	private function get_list_1($list_handle)
	{
		if (feof($list_handle))
			return(null);
		for (;;)
		{
			$s = fgets($list_handle);
			$n = strlen($s);
			while ($n > 0 and strpos("\r\n", $s[$n - 1]) !== false)
				$n--;
			if ($n > 0)
				return(substr($s, 0, $n));
			else if (feof($list_handle))
				return(null);
		}
	}
	
	//-------------------------------------------------------------------
	private function gen_clean_1($file_name, $command_handle, $command_type, $base_location)
	{
		if ($command_type == 'BAT')
		{
			$s = $base_location . str_replace('/', DIR_SEP, $file_name);
			fputs($command_handle, is_dir($s) ? "RMDIR /S /Q \"$s\"" : "DEL /F /S /Q \"$s\"");
		}
		else if ($command_type == 'FTP')
			die('TO DO: ' . __FILE__ . ' ' . __LINE__);
		else
			assert(false);
		fputs($command_handle, LINE_END);
	}
}
?>
