#!/usr/bin/php
<?php
//SYNC Commander
//Main controller
//Chen Qing-can, 2007 autumn, Nanhai China
//[GB2312] ӶϺ

//---------------------------------------------------------------------------
//initialize me
require_once('include/config.php');
require_once('include/lang.php');
require_once('include/args.php');
require_once('include/file_list.php');

print(lang(S_WELCOME));
date_default_timezone_set('UTC');
$WORK_FILE_POSTFIX = date('ymdHis') . substr(microtime(), 2, 2);
$args = new Args();
print(LINE_END);

//---------------------------------------------------------------------------
//file list
$from_file_list_sorted_name = $to_file_list_sorted_name = null;
if ($args->get('--do') == 'sync')
{
	$from_file_list_name = "sync_cmd_from.$WORK_FILE_POSTFIX.txt";
	$from_file_list_sorted_name = "sync_cmd_from_sorted.$WORK_FILE_POSTFIX.txt";
	$to_file_list_name = "sync_cmd_to.$WORK_FILE_POSTFIX.txt";
	$to_file_list_sorted_name = "sync_cmd_to_sorted.$WORK_FILE_POSTFIX.txt";
	if (! gen_file_list($args, '--from', $from_file_list_name))
	{
		unlink($from_file_list_name);
		die;
	}
	system("SORT $from_file_list_name /OUTPUT $from_file_list_sorted_name");
	unlink($from_file_list_name);
	print(LINE_END);
	if (! gen_file_list($args, '--to', $to_file_list_name))
	{
		unlink($to_file_list_name);
		die;
	}
	system("SORT $to_file_list_name /OUTPUT $to_file_list_sorted_name");
	unlink($to_file_list_name);
	print(LINE_END);
}

//---------------------------------------------------------------------------
//prepare deleting command
$del_bat_name = null;
$compare_file_list = new CompareFileList;
if ($args->get('--do') == 'sync')
{
	assert($args->get('--to-protocol') == 'file');
	$del_bat_name = "sync_cmd_del.$WORK_FILE_POSTFIX.bat";
	$from_list = fopen($from_file_list_sorted_name, 'r');
	if (! $from_list)
		die_read_failure($from_file_list_sorted_name);
	$to_list = fopen($to_file_list_sorted_name, 'r');
	if (! $to_list)
		die_read_failure($to_file_list_sorted_name);
	$del_bat = fopen($del_bat_name, 'w');
	if (! $del_bat)
		die_write_failure($del_bat_name);
	if ($args->get('--to-protocol') == 'file')
		fputs($del_bat, "@ECHO OFF\r\n");
	$compare_file_list->gen_clean_to_cmd($from_list, $to_list, $del_bat, 'BAT', $args->get('--to'));
	if (! fclose($del_bat))
		warn_close_failure($del_bat_name);
	if (! fclose($to_list))
		warn_close_failure($to_file_list_sorted_name);
	if (! fclose($from_list))
		warn_close_failure($from_file_list_sorted_name);
}

//---------------------------------------------------------------------------
//give developer a while to check the temp files
/*
print(lang('pause before action'));
system('pause');
*/

//---------------------------------------------------------------------------
//delete
if (! is_null($del_bat_name))
{
	print($del_bat_name); print(LINE_END);
	system($del_bat_name); print(LINE_END);
}

//---------------------------------------------------------------------------
//copy
$cmd = '';
if ($args->get('--from-protocol') == 'ftp' and $args->get('--to-protocol') == 'file')
{
	$cmd = 'wget --no-verbose --recursive --level=inf --no-host-directories' .
		' "--directory-prefix=' . $args->get('--to') . '"' .
		' --cut-dirs=' . (substr_count($args->get('--from'), '/') - 1) .
		' "--user=' . $args->get('--from-user') . '"' .
		' "--password=' . $args->get('--from-password') . '"';
	if ($args->get('--do') == 'update' or $args->get('--do') == 'sync')
		$cmd .= ' --timestamping';
	$cmd .= ' "ftp://' . $args->get('--from-host') .
		':' . $args->get('--from-port') .
		$args->get('--from') . '"';
}

else if ($args->get('--from-protocol') == 'file' and $args->get('--to-protocol') == 'file')
{
	$cmd = 'XCOPY ' . $args->get('--from') . ' ' . $args->get('--to') . ' /Y /S';
	if ($args->get('--do') == 'update' or $args->get('--do') == 'sync')
		$cmd .= ' /D';
}

else if ($args->get('--from-protocol') == 'file' and $args->get('--to-protocol') == 'ftp')
{
	$cmd = 'wput --less-verbose --binary --basename=' . $args->get('--from');
	if ($args->get('--do') == 'copy')
		$cmd .= ' --reupload';
	else if ($args->get('--do') == 'update' or $args->get('--do') == 'sync')
		$cmd .= ' --timestamping';
	else assert(false);
	$cmd .= ' ' . $args->get('--from') .
		' ftp://' . $args->get('--to-user') . ':' . $args->get('--to-password') . '@' . $args->get('--to-host') . ':' . $args->get('--to-port') . $args->get('--to');
}

else assert(false);
print($cmd); print(LINE_END);
system($cmd);

//---------------------------------------------------------------------------
//clean up
if (! is_null($from_file_list_sorted_name))
	unlink($from_file_list_sorted_name);
if (! is_null($to_file_list_sorted_name))
	unlink($to_file_list_sorted_name);
if (! is_null($del_bat_name))
	unlink($del_bat_name);

//---------------------------------------------------------------------------
function gen_file_list($args, $arg_prefix, $file_list_name)
{
	$protocol = $args->get("$arg_prefix-protocol");
	$file_list = null;
	if ($protocol == 'file')
		$file_list = new DiskFileList();
	else if ($protocol == 'ftp')
		$file_list = new FTPFileList($args->get("$arg_prefix-host"), $args->get("$arg_prefix-port"), $args->get("$arg_prefix-user"), $args->get("$arg_prefix-password"));
	$h = fopen($file_list_name, 'w');
	if (! $h)
	{
		err_write_failure($file_list_name);
		return(false);
	}
	$list_to_file_ok = $file_list->list_to_file($args->get("$arg_prefix"), $h);
	if (! fclose($h))
		warn_close_failure($file_list_name);
	return($list_to_file_ok);
}

//---------------------------------------------------------------------------
function die_read_failure($file_name)
{ die(lang('Error: Failed to read ') . $file_name); }

function err_write_failure($file_name)
{ print(lang('Error: Failed to write ') . $file_name); }

function die_write_failure($file_name)
{ die(lang('Error: Failed to write ') . $file_name); }

function warn_close_failure($file_name)
{ print(lang('Warning: Failed to close ') . $file_name); }
?>
